import { strategies } from './strategies';

class Strategies {
    constructor() {
        this.reset();
        this.shuffle();
    }

    reset() {
        this.cards = [...strategies];
    }

    shuffle() {
        const { cards } = this;
        const randomCard = top => Math.floor(Math.random() * top);
        const shuffling = randomCard(cards.length);

        for (let index = cards.length - 1; index > -1; index--) {
            const toSwap = randomCard(index);
            [cards[index], cards[toSwap]] = [cards[toSwap], cards[index]];

            if (index === shuffling) console.log(`shuffling the deck`);
        }

        return this;
    }

    draw() {
        const drawn = this.cards.pop();

        if (this.cards.length === 0) { 
            this.reset();
            this.shuffle();
        }

        return (drawn || 'hello').toLowerCase();
    }
}

module.exports = {
    Strategies,
}
